# database.py

import mysql.connector
from mysql.connector import Error
import logging

def connect_to_database():
    """برقراری اتصال به دیتابیس"""
    try:
        conn = mysql.connector.connect(**DB_CONFIG)
        return conn
    except Error as err:
        logging.error(f"خطا در اتصال به دیتابیس: {err}")
        return None

def setup_database():
    """راه‌اندازی جداول دیتابیس"""
    conn = connect_to_database()
    if conn:
        try:
            cursor = conn.cursor()
            # جدول کاربران
            cursor.execute('''
                CREATE TABLE IF NOT EXISTS users (
                    user_id INT AUTO_INCREMENT PRIMARY KEY,
                    telegram_id BIGINT UNIQUE,
                    first_name VARCHAR(100),
                    last_name VARCHAR(100),
                    father_name VARCHAR(100),
                    national_id VARCHAR(10) UNIQUE,
                    birth_certificate_no VARCHAR(20),
                    phone VARCHAR(11) UNIQUE,
                    birth_date VARCHAR(10),
                    organization VARCHAR(200),
                    province VARCHAR(100),
                    tracking_code VARCHAR(8) UNIQUE,
                    status ENUM('pending', 'approved', 'rejected', 'needs_correction', 'blocked') DEFAULT 'pending',
                    verification_link1 TEXT,
                    verification_link2 TEXT,
                    verification_link3 TEXT,
                    admin_comment TEXT,
                    registration_date TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
                    last_update TIMESTAMP DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
                ) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci
            ''')

            conn.commit()
            print("جداول با موفقیت ایجاد شدند")
        except Error as err:
            logging.error(f"خطا در ایجاد جداول: {err}")
        finally:
            conn.close()
